﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Odbc;
using System.IO;
using BasicFramework;

//da6e583d-ae07-4955-956b-5fe205448f88
//
// CMS (cms)
// Version 1.0 (#33)
//
// RISE to Bloome Software AB
// RISE to Bloome Software AB, 2010-2011
//
//da6e583d-ae07-4955-956b-5fe205448f88

namespace cms.DB.IBasics
{
	/// <summary>
	/// Return value from method Constants
	/// </summary>
	public struct returnConstants
	{
		public bool? NullBool;
		public DateTime? NullDateTime;
		public double? NullFloat;
		public long? NullInt;
		public string NullString;
		public bool TrueBool;
		public bool FalseBool;
		public string EmptyString;
		public long ZeroInt;
		public long OneInt;
		public long TwoInt;
		public long ThreeInt;
		public long FourInt;
		public long FiveInt;
		public long SixInt;
		public long SevenInt;
		public long EightInt;
		public long NineInt;
		public long TenInt;
	}
	/// <summary>
	/// Return value from method IsEqualInt
	/// </summary>
	public struct returnIsEqualInt
	{
		public bool isEqual;
	}
	/// <summary>
	/// Return value from method IsEqualFloat
	/// </summary>
	public struct returnIsEqualFloat
	{
		public bool isEqual;
	}
	/// <summary>
	/// Return value from method IsEqualDateTime
	/// </summary>
	public struct returnIsEqualDateTime
	{
		public bool isEqual;
	}
	/// <summary>
	/// Return value from method IsEqualString
	/// </summary>
	public struct returnIsEqualString
	{
		public bool isEqual;
	}
	/// <summary>
	/// Return value from method IsEqualBool
	/// </summary>
	public struct returnIsEqualBool
	{
		public bool isEqual;
	}
	/// <summary>
	/// Return value from method DefaultBool
	/// </summary>
	public struct returnDefaultBool
	{
		public bool b;
	}
	/// <summary>
	/// Return value from method DefaultInt
	/// </summary>
	public struct returnDefaultInt
	{
		public long i;
	}
	/// <summary>
	/// Return value from method DefaultDateTime
	/// </summary>
	public struct returnDefaultDateTime
	{
		public DateTime dt;
	}
	/// <summary>
	/// Return value from method DefaultFloat
	/// </summary>
	public struct returnDefaultFloat
	{
		public double f;
	}
	/// <summary>
	/// Return value from method DefaultString
	/// </summary>
	public struct returnDefaultString
	{
		public string s;
	}
	/// <summary>
	/// Return value from method IsGreaterThanDateTime
	/// </summary>
	public struct returnIsGreaterThanDateTime
	{
		public bool isGT;
	}
	/// <summary>
	/// Return value from method IsLessThanDateTime
	/// </summary>
	public struct returnIsLessThanDateTime
	{
		public bool isLT;
	}
	/// <summary>
	/// Return value from method IsGreaterThanOrEqualDateTime
	/// </summary>
	public struct returnIsGreaterThanOrEqualDateTime
	{
		public bool isGTE;
	}
	/// <summary>
	/// Return value from method IsLessThanOrEqualDateTime
	/// </summary>
	public struct returnIsLessThanOrEqualDateTime
	{
		public bool isLTE;
	}
	/// <summary>
	/// Return value from method IsGreaterThanFloat
	/// </summary>
	public struct returnIsGreaterThanFloat
	{
		public bool isGT;
	}
	/// <summary>
	/// Return value from method IsGreaterThanOrEqualFloat
	/// </summary>
	public struct returnIsGreaterThanOrEqualFloat
	{
		public bool isGTE;
	}
	/// <summary>
	/// Return value from method IsLessThanFloat
	/// </summary>
	public struct returnIsLessThanFloat
	{
		public bool isLT;
	}
	/// <summary>
	/// Return value from method IsLessThanOrEqualFloat
	/// </summary>
	public struct returnIsLessThanOrEqualFloat
	{
		public bool isLTE;
	}
	/// <summary>
	/// Return value from method IsGreaterThanInt
	/// </summary>
	public struct returnIsGreaterThanInt
	{
		public bool isGT;
	}
	/// <summary>
	/// Return value from method IsGreaterThanOrEqualInt
	/// </summary>
	public struct returnIsGreaterThanOrEqualInt
	{
		public bool isGTE;
	}
	/// <summary>
	/// Return value from method IsLessThanInt
	/// </summary>
	public struct returnIsLessThanInt
	{
		public bool isLT;
	}
	/// <summary>
	/// Return value from method IsLessThanOrEqualInt
	/// </summary>
	public struct returnIsLessThanOrEqualInt
	{
		public bool isLTE;
	}
	/// <summary>
	/// Return value from method IsGreaterThanString
	/// </summary>
	public struct returnIsGreaterThanString
	{
		public bool isGT;
	}
	/// <summary>
	/// Return value from method IsGreaterThanOrEqualString
	/// </summary>
	public struct returnIsGreaterThanOrEqualString
	{
		public bool isGTE;
	}
	/// <summary>
	/// Return value from method IsLessThanString
	/// </summary>
	public struct returnIsLessThanString
	{
		public bool isLT;
	}
	/// <summary>
	/// Return value from method IsLessThanOrEqualString
	/// </summary>
	public struct returnIsLessThanOrEqualString
	{
		public bool isLTE;
	}
	/// <summary>
	/// Return value from method IsBetweenDateTime
	/// </summary>
	public struct returnIsBetweenDateTime
	{
		public bool isBetween;
	}
	/// <summary>
	/// Return value from method IsBetweenInt
	/// </summary>
	public struct returnIsBetweenInt
	{
		public bool isBetween;
	}
	/// <summary>
	/// Return value from method IsBetweenFloat
	/// </summary>
	public struct returnIsBetweenFloat
	{
		public bool isBetween;
	}
	/// <summary>
	/// Return value from method IsBetweenString
	/// </summary>
	public struct returnIsBetweenString
	{
		public bool isBetween;
	}
	/// <summary>
	/// Return value from method LogicalAnd
	/// </summary>
	public struct returnLogicalAnd
	{
		public bool b;
	}
	/// <summary>
	/// Return value from method LogicalOr
	/// </summary>
	public struct returnLogicalOr
	{
		public bool b;
	}
	/// <summary>
	/// Return value from method LogicalXor
	/// </summary>
	public struct returnLogicalXor
	{
		public bool b;
	}
	/// <summary>
	/// Return value from method LogicalNot
	/// </summary>
	public struct returnLogicalNot
	{
		public bool notB;
	}
	/// <summary>
	/// Return value from method MultiplyInt
	/// </summary>
	public struct returnMultiplyInt
	{
		public long equals;
	}
	/// <summary>
	/// Return value from method MultiplyFloat
	/// </summary>
	public struct returnMultiplyFloat
	{
		public double equals;
	}
	/// <summary>
	/// Return value from method DivideInt
	/// </summary>
	public struct returnDivideInt
	{
		public long equals;
	}
	/// <summary>
	/// Return value from method DivideFloat
	/// </summary>
	public struct returnDivideFloat
	{
		public double equals;
	}
	/// <summary>
	/// Return value from method AddInt
	/// </summary>
	public struct returnAddInt
	{
		public long sum;
	}
	/// <summary>
	/// Return value from method AddFloat
	/// </summary>
	public struct returnAddFloat
	{
		public double sum;
	}
	/// <summary>
	/// Return value from method SubtractInt
	/// </summary>
	public struct returnSubtractInt
	{
		public long difference;
	}
	/// <summary>
	/// Return value from method SubtractFloat
	/// </summary>
	public struct returnSubtractFloat
	{
		public double difference;
	}
	/// <summary>
	/// Return value from method Modulo
	/// </summary>
	public struct returnModulo
	{
		public long modulo;
	}
	/// <summary>
	/// Return value from method NegateInt
	/// </summary>
	public struct returnNegateInt
	{
		public long negI;
	}
	/// <summary>
	/// Return value from method NegateFloat
	/// </summary>
	public struct returnNegateFloat
	{
		public double negF;
	}
	/// <summary>
	/// Return value from method AbortIf
	/// </summary>
	public struct returnAbortIf
	{
		public int methodReturnsNothing;
	}
	/// <summary>
	/// Return value from method AbortIfNot
	/// </summary>
	public struct returnAbortIfNot
	{
		public int methodReturnsNothing;
	}
	/// <summary>
	/// Return value from method ServerDateTime
	/// </summary>
	public struct returnServerDateTime
	{
		public DateTime dateTime;
		public long timems;
		public long timezoneOffset;
	}
	/// <summary>
	/// Return value from method UniversalDateTime
	/// </summary>
	public struct returnUniversalDateTime
	{
		public DateTime dateTime;
		public long timems;
	}
	/// <summary>
	/// Class implementing operations on:
	///     Custom object
	/// </summary>
	public class IBasics
	{
		private string _tempDir = ".";
		private bool _odbcCloseAfterUse;
		private OdbcConnection _dbConnection = null;
		private OdbcTransaction _dbTransaction = null;
		public string TempDir
		{
			get { return _tempDir; }
			set { _tempDir = value; }
		}
		public OdbcConnection DbConnection
		{
			get { return _dbConnection; }
			set { _dbConnection = value; }
		}
		public OdbcTransaction DbTransaction
		{
			get { return _dbTransaction; }
			set { _dbTransaction = value; }
		}
		public IBasics() : this((OdbcConnection)null) { }
		public IBasics(string connectionString) : this(new OdbcConnection(connectionString)) { }
		public IBasics(OdbcConnection dbConnection)
		{
			_dbConnection = dbConnection;
		}
		public IBasics(OdbcConnection dbConnection, OdbcTransaction dbTransaction)
			: this(dbConnection)
		{
			_dbTransaction = dbTransaction;
		}
		protected void DBConnect()
		{
			if (_odbcCloseAfterUse = (_dbConnection.State != ConnectionState.Open))
			{
				_dbConnection.Open();
				if (_dbConnection.Driver.ToLower().StartsWith("myodbc"))
				{
					OdbcCommand cmd = _dbConnection.CreateCommand();
					if (_dbTransaction != null) cmd.Transaction = _dbTransaction;
					cmd.CommandText = "SET sql_mode = 'ANSI'";
					cmd.ExecuteNonQuery();
				}
			}
		}
		protected void DBClose() { if (_odbcCloseAfterUse) _dbConnection.Close(); }
		protected OdbcCommand DBCreateCommand()
		{
			OdbcCommand cmd = _dbConnection.CreateCommand();
			if(_dbTransaction != null) cmd.Transaction = _dbTransaction;
			return cmd;
		}
		/// <summary>
		/// Returns a set of varios constants
		/// perform custom defined operations.
		/// </summary>
		/// <returns>returnConstants</returns>
		public returnConstants Constants()
		{
			returnConstants rv = new returnConstants();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.Constants();
			return rv;
		}
		/// <summary>
		/// Returns true if integers are equal.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="i1"></param>
		/// <param name="i2"></param>
		/// <returns>returnIsEqualInt</returns>
		public returnIsEqualInt IsEqualInt(long i1, long i2)
		{
			returnIsEqualInt rv = new returnIsEqualInt();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsEqualInt(i1, i2);
			return rv;
		}
		/// <summary>
		/// Returns true if floats are equal.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="f1"></param>
		/// <param name="f2"></param>
		/// <returns>returnIsEqualFloat</returns>
		public returnIsEqualFloat IsEqualFloat(double f1, double f2)
		{
			returnIsEqualFloat rv = new returnIsEqualFloat();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsEqualFloat(f1, f2);
			return rv;
		}
		/// <summary>
		/// Returns true if datetimes are equal.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="dt1"></param>
		/// <param name="dt2"></param>
		/// <returns>returnIsEqualDateTime</returns>
		public returnIsEqualDateTime IsEqualDateTime(DateTime dt1, DateTime dt2)
		{
			returnIsEqualDateTime rv = new returnIsEqualDateTime();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsEqualDateTime(dt1, dt2);
			return rv;
		}
		/// <summary>
		/// Returns true if strings are equal.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="s1"></param>
		/// <param name="s2"></param>
		/// <returns>returnIsEqualString</returns>
		public returnIsEqualString IsEqualString(string s1, string s2)
		{
			returnIsEqualString rv = new returnIsEqualString();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsEqualString(s1, s2);
			return rv;
		}
		/// <summary>
		/// Returns true if bools are equal.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="b1"></param>
		/// <param name="b2"></param>
		/// <returns>returnIsEqualBool</returns>
		public returnIsEqualBool IsEqualBool(bool b1, bool b2)
		{
			returnIsEqualBool rv = new returnIsEqualBool();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsEqualBool(b1, b2);
			return rv;
		}
		/// <summary>
		/// Returns the b, if not null, and defaultValue otherwise
		/// perform custom defined operations.
		/// </summary>
		/// <param name="b"></param>
		/// <param name="defaultValue"></param>
		/// <returns>returnDefaultBool</returns>
		public returnDefaultBool DefaultBool(bool? b, bool defaultValue)
		{
			returnDefaultBool rv = new returnDefaultBool();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.DefaultBool(b, defaultValue);
			return rv;
		}
		/// <summary>
		/// Returns i, if not null, and defaultValue otherwise
		/// perform custom defined operations.
		/// </summary>
		/// <param name="i"></param>
		/// <param name="defaultValue"></param>
		/// <returns>returnDefaultInt</returns>
		public returnDefaultInt DefaultInt(long? i, long defaultValue)
		{
			returnDefaultInt rv = new returnDefaultInt();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.DefaultInt(i, defaultValue);
			return rv;
		}
		/// <summary>
		/// Returns dt, if not null, and defaultValue otherwise.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="dt"></param>
		/// <param name="defaultValue"></param>
		/// <returns>returnDefaultDateTime</returns>
		public returnDefaultDateTime DefaultDateTime(DateTime? dt, DateTime defaultValue)
		{
			returnDefaultDateTime rv = new returnDefaultDateTime();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.DefaultDateTime(dt, defaultValue);
			return rv;
		}
		/// <summary>
		/// Returns f, if not null, and defaultValue otherwise.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="f"></param>
		/// <param name="defaultValue"></param>
		/// <returns>returnDefaultFloat</returns>
		public returnDefaultFloat DefaultFloat(double? f, double defaultValue)
		{
			returnDefaultFloat rv = new returnDefaultFloat();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.DefaultFloat(f, defaultValue);
			return rv;
		}
		/// <summary>
		/// Returns s, if not null, and defaultValue otherwise.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="s"></param>
		/// <param name="defaultValue"></param>
		/// <returns>returnDefaultString</returns>
		public returnDefaultString DefaultString(string s, string defaultValue)
		{
			returnDefaultString rv = new returnDefaultString();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			if (defaultValue == null) throw new Exception("defaultValue must not be null!");
			rv = customObject.DefaultString(s, defaultValue);
			return rv;
		}
		/// <summary>
		/// Returns true if d1 is greater (later) than d2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="d1"></param>
		/// <param name="d2"></param>
		/// <returns>returnIsGreaterThanDateTime</returns>
		public returnIsGreaterThanDateTime IsGreaterThanDateTime(DateTime d1, DateTime d2)
		{
			returnIsGreaterThanDateTime rv = new returnIsGreaterThanDateTime();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsGreaterThanDateTime(d1, d2);
			return rv;
		}
		/// <summary>
		/// Returns true if d1 is less (earlier) than d2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="d1"></param>
		/// <param name="d2"></param>
		/// <returns>returnIsLessThanDateTime</returns>
		public returnIsLessThanDateTime IsLessThanDateTime(DateTime d1, DateTime d2)
		{
			returnIsLessThanDateTime rv = new returnIsLessThanDateTime();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsLessThanDateTime(d1, d2);
			return rv;
		}
		/// <summary>
		/// Returns true if d1 is greater (later) than or equal to d2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="d1"></param>
		/// <param name="d2"></param>
		/// <returns>returnIsGreaterThanOrEqualDateTime</returns>
		public returnIsGreaterThanOrEqualDateTime IsGreaterThanOrEqualDateTime(DateTime d1, DateTime d2)
		{
			returnIsGreaterThanOrEqualDateTime rv = new returnIsGreaterThanOrEqualDateTime();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsGreaterThanOrEqualDateTime(d1, d2);
			return rv;
		}
		/// <summary>
		/// Returns true if d1 is less (earlier) then d2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="d1"></param>
		/// <param name="d2"></param>
		/// <returns>returnIsLessThanOrEqualDateTime</returns>
		public returnIsLessThanOrEqualDateTime IsLessThanOrEqualDateTime(DateTime d1, DateTime d2)
		{
			returnIsLessThanOrEqualDateTime rv = new returnIsLessThanOrEqualDateTime();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsLessThanOrEqualDateTime(d1, d2);
			return rv;
		}
		/// <summary>
		/// Returns true if f1 is greater than f2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="f1"></param>
		/// <param name="f2"></param>
		/// <returns>returnIsGreaterThanFloat</returns>
		public returnIsGreaterThanFloat IsGreaterThanFloat(double f1, double f2)
		{
			returnIsGreaterThanFloat rv = new returnIsGreaterThanFloat();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsGreaterThanFloat(f1, f2);
			return rv;
		}
		/// <summary>
		/// Returns true if f1 is greater than or equal to f2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="f1"></param>
		/// <param name="f2"></param>
		/// <returns>returnIsGreaterThanOrEqualFloat</returns>
		public returnIsGreaterThanOrEqualFloat IsGreaterThanOrEqualFloat(double f1, double f2)
		{
			returnIsGreaterThanOrEqualFloat rv = new returnIsGreaterThanOrEqualFloat();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsGreaterThanOrEqualFloat(f1, f2);
			return rv;
		}
		/// <summary>
		/// Returns true if f1 is less than f2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="f1"></param>
		/// <param name="f2"></param>
		/// <returns>returnIsLessThanFloat</returns>
		public returnIsLessThanFloat IsLessThanFloat(double f1, double f2)
		{
			returnIsLessThanFloat rv = new returnIsLessThanFloat();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsLessThanFloat(f1, f2);
			return rv;
		}
		/// <summary>
		/// Returns true if f1 is less than or equal to f2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="f1"></param>
		/// <param name="f2"></param>
		/// <returns>returnIsLessThanOrEqualFloat</returns>
		public returnIsLessThanOrEqualFloat IsLessThanOrEqualFloat(double f1, double f2)
		{
			returnIsLessThanOrEqualFloat rv = new returnIsLessThanOrEqualFloat();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsLessThanOrEqualFloat(f1, f2);
			return rv;
		}
		/// <summary>
		/// Returns true if i1 is greater than i2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="i1"></param>
		/// <param name="i2"></param>
		/// <returns>returnIsGreaterThanInt</returns>
		public returnIsGreaterThanInt IsGreaterThanInt(long i1, long i2)
		{
			returnIsGreaterThanInt rv = new returnIsGreaterThanInt();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsGreaterThanInt(i1, i2);
			return rv;
		}
		/// <summary>
		/// Returns true if i1 is greater than or equal to  i2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="i1"></param>
		/// <param name="i2"></param>
		/// <returns>returnIsGreaterThanOrEqualInt</returns>
		public returnIsGreaterThanOrEqualInt IsGreaterThanOrEqualInt(long i1, long i2)
		{
			returnIsGreaterThanOrEqualInt rv = new returnIsGreaterThanOrEqualInt();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsGreaterThanOrEqualInt(i1, i2);
			return rv;
		}
		/// <summary>
		/// Returns true if i1 is less than i2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="i1"></param>
		/// <param name="i2"></param>
		/// <returns>returnIsLessThanInt</returns>
		public returnIsLessThanInt IsLessThanInt(long i1, long i2)
		{
			returnIsLessThanInt rv = new returnIsLessThanInt();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsLessThanInt(i1, i2);
			return rv;
		}
		/// <summary>
		/// Returns true if i1 is less than or equal to i2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="i1"></param>
		/// <param name="i2"></param>
		/// <returns>returnIsLessThanOrEqualInt</returns>
		public returnIsLessThanOrEqualInt IsLessThanOrEqualInt(long i1, long i2)
		{
			returnIsLessThanOrEqualInt rv = new returnIsLessThanOrEqualInt();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsLessThanOrEqualInt(i1, i2);
			return rv;
		}
		/// <summary>
		/// Returns true if s1 is greater than s2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="s1"></param>
		/// <param name="s2"></param>
		/// <returns>returnIsGreaterThanString</returns>
		public returnIsGreaterThanString IsGreaterThanString(string s1, string s2)
		{
			returnIsGreaterThanString rv = new returnIsGreaterThanString();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			if (s1 == null) throw new Exception("s1 must not be null!");
			if (s2 == null) throw new Exception("s2 must not be null!");
			rv = customObject.IsGreaterThanString(s1, s2);
			return rv;
		}
		/// <summary>
		/// Returns true if s1 is greater than or equal to s2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="s1"></param>
		/// <param name="s2"></param>
		/// <returns>returnIsGreaterThanOrEqualString</returns>
		public returnIsGreaterThanOrEqualString IsGreaterThanOrEqualString(string s1, string s2)
		{
			returnIsGreaterThanOrEqualString rv = new returnIsGreaterThanOrEqualString();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			if (s1 == null) throw new Exception("s1 must not be null!");
			if (s2 == null) throw new Exception("s2 must not be null!");
			rv = customObject.IsGreaterThanOrEqualString(s1, s2);
			return rv;
		}
		/// <summary>
		/// Returns true if s1 is less than s2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="s1"></param>
		/// <param name="s2"></param>
		/// <returns>returnIsLessThanString</returns>
		public returnIsLessThanString IsLessThanString(string s1, string s2)
		{
			returnIsLessThanString rv = new returnIsLessThanString();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			if (s1 == null) throw new Exception("s1 must not be null!");
			if (s2 == null) throw new Exception("s2 must not be null!");
			rv = customObject.IsLessThanString(s1, s2);
			return rv;
		}
		/// <summary>
		/// Returns true if s1 is less than or equal to s2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="s1"></param>
		/// <param name="s2"></param>
		/// <returns>returnIsLessThanOrEqualString</returns>
		public returnIsLessThanOrEqualString IsLessThanOrEqualString(string s1, string s2)
		{
			returnIsLessThanOrEqualString rv = new returnIsLessThanOrEqualString();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			if (s1 == null) throw new Exception("s1 must not be null!");
			if (s2 == null) throw new Exception("s2 must not be null!");
			rv = customObject.IsLessThanOrEqualString(s1, s2);
			return rv;
		}
		/// <summary>
		/// Returns true if dtMin <= dt <= dtMax
		/// perform custom defined operations.
		/// </summary>
		/// <param name="dtMin"></param>
		/// <param name="dt"></param>
		/// <param name="dtMax"></param>
		/// <returns>returnIsBetweenDateTime</returns>
		public returnIsBetweenDateTime IsBetweenDateTime(DateTime dtMin, DateTime dt, DateTime dtMax)
		{
			returnIsBetweenDateTime rv = new returnIsBetweenDateTime();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsBetweenDateTime(dtMin, dt, dtMax);
			return rv;
		}
		/// <summary>
		/// Returns true if iMin <= i <= iMax.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="iMin"></param>
		/// <param name="i"></param>
		/// <param name="iMax"></param>
		/// <returns>returnIsBetweenInt</returns>
		public returnIsBetweenInt IsBetweenInt(long iMin, long i, long iMax)
		{
			returnIsBetweenInt rv = new returnIsBetweenInt();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsBetweenInt(iMin, i, iMax);
			return rv;
		}
		/// <summary>
		/// Returns true if fMin <= f <= fMax.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="fMin"></param>
		/// <param name="f"></param>
		/// <param name="fMax"></param>
		/// <returns>returnIsBetweenFloat</returns>
		public returnIsBetweenFloat IsBetweenFloat(double fMin, double f, double fMax)
		{
			returnIsBetweenFloat rv = new returnIsBetweenFloat();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.IsBetweenFloat(fMin, f, fMax);
			return rv;
		}
		/// <summary>
		/// Returns true if sMin <= s <= sMax.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="sMin"></param>
		/// <param name="s"></param>
		/// <param name="sMax"></param>
		/// <returns>returnIsBetweenString</returns>
		public returnIsBetweenString IsBetweenString(string sMin, string s, string sMax)
		{
			returnIsBetweenString rv = new returnIsBetweenString();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			if (sMin == null) throw new Exception("sMin must not be null!");
			if (s == null) throw new Exception("s must not be null!");
			if (sMax == null) throw new Exception("sMax must not be null!");
			rv = customObject.IsBetweenString(sMin, s, sMax);
			return rv;
		}
		/// <summary>
		/// Returns true is b1 and b2 is true.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="b1"></param>
		/// <param name="b2"></param>
		/// <returns>returnLogicalAnd</returns>
		public returnLogicalAnd LogicalAnd(bool b1, bool b2)
		{
			returnLogicalAnd rv = new returnLogicalAnd();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.LogicalAnd(b1, b2);
			return rv;
		}
		/// <summary>
		/// Returns true if b1 is true or b2 is true or both are true.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="b1"></param>
		/// <param name="b2"></param>
		/// <returns>returnLogicalOr</returns>
		public returnLogicalOr LogicalOr(bool b1, bool b2)
		{
			returnLogicalOr rv = new returnLogicalOr();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.LogicalOr(b1, b2);
			return rv;
		}
		/// <summary>
		/// Returns true if b1 is true or b2 is true but both are not true.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="b1"></param>
		/// <param name="b2"></param>
		/// <returns>returnLogicalXor</returns>
		public returnLogicalXor LogicalXor(bool b1, bool b2)
		{
			returnLogicalXor rv = new returnLogicalXor();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.LogicalXor(b1, b2);
			return rv;
		}
		/// <summary>
		/// Returns true if b is false and false if b is true.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="b"></param>
		/// <returns>returnLogicalNot</returns>
		public returnLogicalNot LogicalNot(bool b)
		{
			returnLogicalNot rv = new returnLogicalNot();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.LogicalNot(b);
			return rv;
		}
		/// <summary>
		/// Returns i1 times i2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="i1"></param>
		/// <param name="i2"></param>
		/// <returns>returnMultiplyInt</returns>
		public returnMultiplyInt MultiplyInt(long i1, long i2)
		{
			returnMultiplyInt rv = new returnMultiplyInt();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.MultiplyInt(i1, i2);
			return rv;
		}
		/// <summary>
		/// Returns f1 times f2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="f1"></param>
		/// <param name="f2"></param>
		/// <returns>returnMultiplyFloat</returns>
		public returnMultiplyFloat MultiplyFloat(double f1, double f2)
		{
			returnMultiplyFloat rv = new returnMultiplyFloat();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.MultiplyFloat(f1, f2);
			return rv;
		}
		/// <summary>
		/// Returns the integer part of iDividend divided with iDivisor.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="iDividend"></param>
		/// <param name="iDivisor"></param>
		/// <returns>returnDivideInt</returns>
		public returnDivideInt DivideInt(long iDividend, long iDivisor)
		{
			returnDivideInt rv = new returnDivideInt();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.DivideInt(iDividend, iDivisor);
			return rv;
		}
		/// <summary>
		/// Returns fDividend divided with fDivisor.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="fDividend"></param>
		/// <param name="fDivisor"></param>
		/// <returns>returnDivideFloat</returns>
		public returnDivideFloat DivideFloat(double fDividend, double fDivisor)
		{
			returnDivideFloat rv = new returnDivideFloat();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.DivideFloat(fDividend, fDivisor);
			return rv;
		}
		/// <summary>
		/// Returns i1 plus i2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="i1"></param>
		/// <param name="i2"></param>
		/// <returns>returnAddInt</returns>
		public returnAddInt AddInt(long i1, long i2)
		{
			returnAddInt rv = new returnAddInt();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.AddInt(i1, i2);
			return rv;
		}
		/// <summary>
		/// Returns f1 plus f2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="f1"></param>
		/// <param name="f2"></param>
		/// <returns>returnAddFloat</returns>
		public returnAddFloat AddFloat(double f1, double f2)
		{
			returnAddFloat rv = new returnAddFloat();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.AddFloat(f1, f2);
			return rv;
		}
		/// <summary>
		/// Returns i1 minus i2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="i1"></param>
		/// <param name="i2"></param>
		/// <returns>returnSubtractInt</returns>
		public returnSubtractInt SubtractInt(long i1, long i2)
		{
			returnSubtractInt rv = new returnSubtractInt();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.SubtractInt(i1, i2);
			return rv;
		}
		/// <summary>
		/// Returns f1 minus f2.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="f1"></param>
		/// <param name="f2"></param>
		/// <returns>returnSubtractFloat</returns>
		public returnSubtractFloat SubtractFloat(double f1, double f2)
		{
			returnSubtractFloat rv = new returnSubtractFloat();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.SubtractFloat(f1, f2);
			return rv;
		}
		/// <summary>
		/// Returns the modulo (remainder) when dividing iDividend by iDivisor.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="iDividend"></param>
		/// <param name="iDivisor"></param>
		/// <returns>returnModulo</returns>
		public returnModulo Modulo(long iDividend, long iDivisor)
		{
			returnModulo rv = new returnModulo();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.Modulo(iDividend, iDivisor);
			return rv;
		}
		/// <summary>
		/// Returns i times -1.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="i"></param>
		/// <returns>returnNegateInt</returns>
		public returnNegateInt NegateInt(long i)
		{
			returnNegateInt rv = new returnNegateInt();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.NegateInt(i);
			return rv;
		}
		/// <summary>
		/// Returns f times -1.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="f"></param>
		/// <returns>returnNegateFloat</returns>
		public returnNegateFloat NegateFloat(double f)
		{
			returnNegateFloat rv = new returnNegateFloat();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.NegateFloat(f);
			return rv;
		}
		/// <summary>
		/// Raises an exception to abort execution if b is true.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="b"></param>
		/// <returns>returnAbortIf</returns>
		public returnAbortIf AbortIf(bool b)
		{
			returnAbortIf rv = new returnAbortIf();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.AbortIf(b);
			return rv;
		}
		/// <summary>
		/// Raises an exception to abort execution if b is false.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="b"></param>
		/// <returns>returnAbortIfNot</returns>
		public returnAbortIfNot AbortIfNot(bool b)
		{
			returnAbortIfNot rv = new returnAbortIfNot();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.AbortIfNot(b);
			return rv;
		}
		/// <summary>
		/// Returns the server DateTime, including the timezone offset and time in ms since epoch (Javascript style). The argument timems is is the time in ms since epoch. If timems is NULL the current time is used.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="timems"></param>
		/// <returns>returnServerDateTime</returns>
		public returnServerDateTime ServerDateTime(long? timems)
		{
			returnServerDateTime rv = new returnServerDateTime();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.ServerDateTime(timems);
			return rv;
		}
		/// <summary>
		/// Returns the UTC DateTime, including the time in ms since epoch (Javascript style). The argument timems is is the time in ms since epoch. If timems is NULL the current time at UTC is used.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="timems"></param>
		/// <returns>returnUniversalDateTime</returns>
		public returnUniversalDateTime UniversalDateTime(long? timems)
		{
			returnUniversalDateTime rv = new returnUniversalDateTime();
			BasicFramework.Basics customObject = new BasicFramework.Basics();
			rv = customObject.UniversalDateTime(timems);
			return rv;
		}
	}
}
