﻿if (CMS && CMS.admin) {
	CMS.admin.toolbar = {
		markupIDs: {
			container: "topToolbar"
		}, 
		load: function(){
			var toolbarEl = document.getElementById(CMS.admin.toolbar.markupIDs["container"]);
			if(toolbarEl) {
				var ph = function(phrase){ return CMS.admin.language.phrase("toolbar", phrase); }
				var toolbarImages = [];
				var group = [];
				
				group[group.length] = { src: "images/refreshSites.png", alt: ph("refreshTooltip"), title: ph("refreshTooltip"), onclick: function(ev){ CMS.admin.tree.load(); } };
				toolbarImages[toolbarImages.length] = group;

				group = [];
				var rightImages = [];
				
				group[group.length] = { src: "Images/logout.png", alt: ph("logOut"), title: ph("logOut"), onclick: function(ev){ window.CMSLogout(); } };
				rightImages[rightImages.length] = group;
				group = [];
				
				group[group.length] = { src:"Images/OTR_BlueText.png", alt: "RISE to Bloome Software", title: "RISE to Bloome Software", width: "65px", height: "30px", onclick: function(ev){ window.open("http://www.risetobloome.com"); } };
				rightImages[rightImages.length] = group; 

				new RISE.Toolbar(toolbarEl, {imageWidth: 32, imageHeight: 32, imageBlocks: toolbarImages, rightBlocks: rightImages}).render();				
			}
		}
	}
} else {
	alert("CMSAdminToolbar: missing dependencies");
}