﻿if (CMS) {
    if(!CMS.config){
        CMS.config = {};
	    CMS.config.environment = ".NET";
    	CMS.config.persistentCookies = true;
    	
		CMS.config.articleEditors = [
			{ name: "Text", value: "Text", isDefault: false }, 
			{ name: "Xinha", value: "Xinha", isDefault: true } 
		];
		
		CMS.config.defaultArticleEditor = function() {
			for(var i=0; i<CMS.config.articleEditors.length; i++) {
				if(CMS.config.articleEditors[i]["isDefault"]) {
					return CMS.config.articleEditors[i]["name"];
				}
			}
			return null;
		};
		
	    if(CMS.config.environment == "PHP"){
		    if(window.IAdmin){ 
			    window.IAdmin.wsuri = "../service/cms.WS.IAdmin.php";
			    window.IAdmin.wsenvironment = CMS.config.environment;
		    }
		    if(window.IEdit){ 
			    window.IEdit.wsuri = "../service/cms.WS.IEdit.php";
			    window.IEdit.wsenvironment = CMS.config.environment;
		    }
		    if(window.IPublished){ 
			    window.IPublished.wsuri = "../service/cms.WS.IPublished.php";
			    window.IPublished.wsenvironment = CMS.config.environment;
		    }
		    if(window.ISession){ 
			    window.ISession.wsuri = "../service/cms.WS.ISession.php";
			    window.ISession.wsenvironment = CMS.config.environment;
		    }
		    CMS.config.display = "../service/display.php";
		    CMS.config.thumbnail = "../service/thumbnail.php";
		    CMS.config.upload = "../service/upload.php";
		    
		    CMS.config.xinha = {};
		    CMS.config.xinha.cmsImage = {};
		    CMS.config.xinha.cmsImage.thumbnail = "../service/thumbnail.php?content=";
		    CMS.config.xinha.cmsImage.image = "../service/display.php?content=";
		    CMS.config.xinha.cmsImage.width = 660;
		    CMS.config.xinha.cmsImage.height = 490;
		    CMS.config.xinha.cmsLink = {};
		    CMS.config.xinha.cmsLink.link = "../service/display.php?content=";
		    CMS.config.xinha.cmsLink.width = 660;
		    CMS.config.xinha.cmsLink.height = 490;
		    CMS.config.xinha.stylistLoadStylesheet = "CMSArticleEditor/style.css";
		    
	    } else if(CMS.config.environment == ".NET"){
		    if(window.IAdmin){ 
			    window.IAdmin.wsuri = "../service/cms.WS.IAdmin.asmx";
			    window.IAdmin.wsenvironment = CMS.config.environment;
		    }
		    if(window.IEdit){ 
			    window.IEdit.wsuri = "../service/cms.WS.IEdit.asmx";
			    window.IEdit.wsenvironment = CMS.config.environment;
		    }
		    if(window.IPublished){ 
			    window.IPublished.wsuri = "../service/cms.WS.IPublished.asmx";
			    window.IPublished.wsenvironment = CMS.config.environment;
		    }
		    if(window.ISession){ 
			    window.ISession.wsuri = "../service/cms.WS.ISession.asmx";
			    window.ISession.wsenvironment = CMS.config.environment;
		    }
		    CMS.config.display = "../service/display.aspx";
		    CMS.config.thumbnail = "../service/thumbnail.aspx";
		    CMS.config.upload = "../service/upload.aspx";
		    
		    CMS.config.xinha = {};
		    CMS.config.xinha.cmsImage = {};
		    CMS.config.xinha.cmsImage.thumbnail = "../service/thumbnail.aspx?content=";
		    CMS.config.xinha.cmsImage.image = "../service/display.aspx?content=";
		    CMS.config.xinha.cmsImage.width = 660;
		    CMS.config.xinha.cmsImage.height = 490;
		    CMS.config.xinha.cmsLink = {};
		    CMS.config.xinha.cmsLink.link = "../service/display.aspx?content=";
		    CMS.config.xinha.cmsLink.width = 660;
		    CMS.config.xinha.cmsLink.height = 490;
		    CMS.config.xinha.stylistLoadStylesheet = "CMSArticleEditor/style.css";
	    }
    }
} else {
	alert("CMSAdmin: missing dependencies");
}