﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="upload.aspx.cs" Inherits="service.upload" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <script type="text/javascript">
        // Implementation of the JSONP callback
        function OnJsonp(obj) {
            document.getElementById('result').innerHTML = '<b>Upload ' + (!obj.succes ? 'failed' : 'OK') + '</b>, ' + obj.images.length.toString() + ' images and ' + obj.documents.length.toString() + ' documents uploaded!';
        }
        // Called when DOM ready
        function RunJsonp() {
            <%= JSONP %>
        }
    </script>
    <title>Upload</title>
</head>
<body onload="RunJsonp();">
    <form name="form1" enctype="multipart/form-data" method="post">
    <div>
        <!--
            FORM FIELDS
            callback  JSONP callback to receive result information object, see example above.
            ticket    Session ticket, must match session cookie for authentication.
            content   OPTIONAL. ID of content to update. 
            site      OPTIONAL. ID of Site, where to store new content. Ignored if [xxx]_content is set.
            parent    OPTIONAL. ID of parent content, under which to store new content. Ignored if [xxx]_content is set.
            type      OPTIONAL. Type of new content, Image or Document. Ignored if [xxx]_content is set.
            Any file field  Contains actual file to upload. 
        -->
        <div id="result"></div>
        <input name="callback" id="callback" type="hidden" value="OnJsonp" />
        <input name="ticket" id="ticket" type="hidden" value="<%= Ticket %>" />
        <h1>Provide file upload information</h1>
        <table cellpadding=0 cellspacing=0>
            <tr>
                <td style="width: 120px"><b>Action</b></td>
                <td>
                    <select id="Select2" onchange="document.getElementById('panel1').style.display=(this.selectedIndex==0?'block':'none');document.getElementById('panel2').style.display=(this.selectedIndex==1?'block':'none');">
                        <option value="New">Upload new content</option>
                        <option value="Update">Update existing content</option>
                    </select>
                </td>
            </tr>
            <tr>
                <td colspan="2">
                    <div id="panel1">
                        <table  cellpadding=0 cellspacing=0>
                            <tr>
                                <td style="width: 120px"><b>Site ID</b></td>
                                <td><input name="site" type="text" /></td>
                            </tr>
                            <tr>
                                <td style="width: 120px"><b>Parent ID</b></td>
                                <td><input name="parent" type="text" /></td>
                            </tr>
                            <tr>
                                <td style="width: 120px"><b>Type</b></td>
                                <td><input name="type" id="type" type="hidden" />
                                    <select id="Select3" onchange="document.getElementById('type').value=this.value;">
                                        <option value="Document">Document</option>
                                        <option value="Image">Image</option>
                                    </select>
                                </td>
                            </tr>
                        </table>
                    </div>
                    <div id="panel2" style="display:none;">
                        <table cellpadding=0 cellspacing=0>
                            <tr>
                                <td style="width: 120px"><b>Content ID</b></td>
                                <td><input name="content" type="text" /></td>
                            </tr>
                        </table>
                    </div>
                </td>
            </tr>
            <tr>
                <td style="width: 120px"><b>File to upload</b></td>
                <td><input name="File1" type="file" /></td>
            </tr>
        </table>
        <input id="Submit1" type="submit" value="submit" />
    </div>
    </form>
</body>
</html>

