﻿if (CMS && CMS.editor) {
	CMS.editor.language = {
	    userLanguage: null,
	    defaultLanguage: "en",

		en: {
			top: {
				
			}, 
			left: {
				title: "Sites", 
				recycleBin: "Recycle Bin", 
				
				contextMenuAddFolder: "Add Folder", 
				contextMenuAddLink: "Add Link", 
				contextMenuAddDocument: "Add Document", 
				contextMenuAddImage: "Add Image", 
				contextMenuAddArticle: "Add Article", 
				contextMenuAddMessage: "Add Message", 
				contextMenuDeleteNode: "Delete Node", 

				newFolderName: "New Folder", 
				newLinkName: "New Link", 
				newDocumentName: "New Document", 
				newImageName: "New Image", 
				newArticleName: "New Article", 
				newMessageName: "New Message",
				
				confirmLoadSiteStart: "The site tree \"", 
				confirmLoadSiteEnd: "\" is not loaded. Do you want to load the site and highlight the selected content?",

				alertMessagesNotAllowedForContent: "This node does not allow messages", 
				alertMessagesNotAllowedForSite: "You cannot add messages to a site", 
				confirmDeleteContentStart: "Do you want do delete \"", 
				confirmDeleteContentEnd: "\"?", 
				alertDeleteSiteInAdminGui: "Sites cannot be removed using this GUI", 
				alertErrorDeletingContent: "Error deleting content", 
				alertErrorCreatingFolder: "Error creating folder", 
				alertErrorCreatingLink: "Error creating link", 
				alertErrorCreatingDocument: "Error creating document", 
				alertErrorCreatingImage: "Error creating image", 
				alertErrorCreatingArticle: "Error creating article", 
				alertErrorCreatingMessage: "Error creating message", 
				alertErrorMovingContent: "Error moving content", 
				alertMissingDependencies: "CMSSiteTree: missing dependencies", 
				alertErrorLoadingSites: "Error loading sites", 
				alertErrorLoadingContentNodes: "Error loading site content nodes"
			}, 
			center: {
				typeSite: "Site", 
				typeFolder: "Folder", 
				typeLink: "Link", 
				typeDocument: "Document", 
				typeImage: "Image", 
				typeArticke: "Article", 
				typeMessage: "Message", 
				
				toolbarAddFolder: "Add Folder", 
				toolbarAddLink: "Add Link", 
				toolbarAddDocument: "Add Document", 
				toolbarAddImage: "Add Image", 
				toolbarAddArticle: "Add Article", 
				toolbarAddMessage: "Add Message", 
				toolbarDeleteNode: "Delete", 
				
				groupBasic: "Basics", 
				propContentFriendlyName: "Friendly Name", 
				propContentTitle: "Title", 
				propContentSortOrder: "Sort Order", 
				propContentType: "Type", 
				propContentID: "ID", 
				propContentPublished: "Published", 
				propContentAllowMessages: "Allow Messages",
				propContentCustom: "Custom", 
				propContentSUID: "System Unique ID", 
				propContentAbstract: "Abstract",
				propArticleHint: "Display Hint", 
				
				groupArticle: "Article", 
				propArticleEditor: "Editor", 
				propArticleData: "Data Length", 
				propEditArticle: "Edit Article", 
				articleEditLinkLabel: "Open Article Editor", 
				
				groupDocument: "Document", 
				propDocumentMimeType: "Mime Type", 
				propDocumentDownload: "Download", 
				propDocumentUpload: "Upload New", 
				documentDownloadLinkLabel: "Download Document", 
				
				groupImage: "Image", 
				propImageMimeType: "Mime Type", 
				propImageSize: "Size", 
				propImageDownload: "Download", 
				propImageUpload: "Upload New", 
				propImageAlternative: "Alternative Text",
				propImageThumb: "Thumbnail", 
				imageDownloadLinkLabel: "Download Image", 
				
				groupLink: "Link", 
				propLinkTargetURI: "Target Content", 
				propLinkTargetURITooltip: "Enter the content id of the content you want to reference.", 
				propLinkTargetURIFind: "Find Content",
				propLinkTargetURL: "Target URL", 
				propLinkTargetURLTooltip: "Enter a url to external content", 
				
				groupMessage: "Message", 
				propMessageSource: "Source", 
				propMessageData: "Data",
				
				groupMetaTags: "Meta Tags", 
				propContentKeywords: "Keywords", 
				propContentDescription: "Description", 
				propContentRobots: "Robots", 
				propContentLanguage: "Language", 
				
				alertErrorLoadingContent: "Error loading content", 
				alertErrorSavingFolder: "Error saving folder", 
				alertErrorSavingLink: "Error saving link", 
				alertErrorSavingDocument: "Error saving document", 
				alertErrorSavingImage: "Error saving image", 
				alertErrorSavingArticle: "Error saving article", 
				alertErrorSavingMessage: "Error saving message", 
				alertContentDataMissing: "Your last change has not be saved. The content was replaced before the save operation was completed.", 
				alertContentMustHaveTitle: "Content must have a title", 
				alertUnknownData: "Unknown data, save failed", 
				alertMissingDependencies: "CMSNodeProperties: missing dependencies"
			}, 
			search: {
				columnType: "Type", 
				columnSite: "Site", 
				columnTitle: "Title", 

				byTitleHeader: "Search content by Title", 
				byTitleFilterLabel: "Title contains:", 
				byTitleButtonText: "Search", 

				byArticleTextHeader: "Search content by Article text", 
				byArticleTextFilterLabel: "Article contains:", 
				byArticleTextButtonText: "Search", 

				byTargetURIHeader: "Search content by Target URI", 
				byTargetURIFilterLabel: "Target URI:", 
				byTargetURIButtonText: "Search", 

				typeFolderTooltip: "Folder", 
				typeLinkTooltip: "Link", 
				typeDocumentTooltip: "Document", 
				typeImageTooltip: "Image", 
				typeArticleTooltip: "Article", 
				typeMessageTooltip: "Message", 
				typeUnknownTooltip: "Unknown type", 
				
				alertErrorLoading: "CMSSearch: missing dependencies"
			}, 
			toolbar: {
				refreshTooltip: "Refresh site tree", 
				searchByTitleTooltip: "Find content by title", 
				searchByArticleTextTooltip: "Find article by article text", 
				searchByTargetURITooltip: "Find content by target URI", 
                logOut: "Log Out"
			}
		}, 
		sv: {
			top: {
				
			}, 
			left: {
				title: "Sajter", 
				recycleBin: "Papperskorg", 

				contextMenuAddFolder: "Ny Katalog", 
				contextMenuAddLink: "Ny Länk", 
				contextMenuAddDocument: "Nytt Dokument", 
				contextMenuAddImage: "Ny Bild", 
				contextMenuAddArticle: "Ny Artikel", 
				contextMenuAddMessage: "Nytt Meddelande", 
				contextMenuDeleteNode: "Kasta Nod", 

				newFolderName: "Ny Katalog", 
				newLinkName: "Ny Länk", 
				newDocumentName: "Nytt Dokument", 
				newImageName: "Ny Bild", 
				newArticleName: "Ny Artikel", 
				newMessageName: "Nytt Meddelande",
				
				confirmLoadSiteStart: "Sajten \"", 
				confirmLoadSiteEnd: "\" är inte laddad. Vill du ladda sajten och markera det valda innehållet?",

				alertMessagesNotAllowedForContent: "Den valda noden tillåter inte meddelanden", 
				alertMessagesNotAllowedForSite: "En sajt kan inte ha meddelanden", 
				confirmDeleteContentStart: "Vill du ta bort \"", 
				confirmDeleteContentEnd: "\"?", 
				alertDeleteSiteInAdminGui: "Sajter kan endast tas bort via admin-gränssnittet", 
				alertErrorDeletingContent: "Noden kunde inte tas bort", 
				alertErrorCreatingFolder: "Ett fel uppstod vid skapande av katalog", 
				alertErrorCreatingLink: "Ett fel uppstod vid skapande av länk", 
				alertErrorCreatingDocument: "Ett fel uppstod vid skapande av dokument", 
				alertErrorCreatingImage: "Ett fel uppstod vid skapande av bild", 
				alertErrorCreatingArticle: "Ett fel uppstod vid skapande av artikel", 
				alertErrorCreatingMessage: "Ett fel uppstod vid skapande av meddelande", 
				alertErrorMovingContent: "Ett fel uppstod vid flyttande av innehåll", 
				alertErrorLoading: "CMSSiteTree: missing dependencies", 
				alertErrorLoadingSites: "Ett fel uppstod vid laddande av sajter", 
				alertErrorLoadingContentNodes: "Ett fel uppstod vid laddande av sajt-noder"
			}, 
			center: {
				typeSite: "Sajt", 
				typeFolder: "Katalog", 
				typeLink: "Länk", 
				typeDocument: "Dokument", 
				typeImage: "Bild", 
				typeArticke: "Artikel", 
				typeMessage: "Meddelande", 
				
				toolbarAddFolder: "Ny katalog", 
				toolbarAddLink: "Ny länk", 
				toolbarAddDocument: "Nytt dokument", 
				toolbarAddImage: "Ny bild", 
				toolbarAddArticle: "Ny artikel", 
				toolbarAddMessage: "Nytt meddelande", 
				toolbarDeleteNode: "Kasta", 

				groupBasic: "Grundläggande", 
				propContentFriendlyName: "Välkänt namn", 
				propContentTitle: "Titel", 
				propContentSortOrder: "Sorteringsordning", 
				propContentType: "Typ", 
				propContentID: "ID", 
				propContentPublished: "Publicerad", 
				propContentAllowMessages: "Tillåt meddelanden", 
				propContentCustom: "Eget data", 
				propContentSUID: "Systemunikt ID", 
				propContentAbstract: "Sammanfattning",
				propArticleHint: "Visningsläge", 
				
				groupArticle: "Artikel", 
				propArticleEditor: "Editor", 
				propArticleData: "Datalängd", 
				propEditArticle: "Editera", 
				articleEditLinkLabel: "Öppna artikeleditor", 
				
				groupDocument: "Dokument", 
				propDocumentMimeType: "Mime-typ", 
				propDocumentDownload: "Ladda ner", 
				propDocumentUpload: "Ladda upp ny", 
				documentDownloadLinkLabel: "Ladda ner dokument", 
				
				groupImage: "Bild", 
				propImageMimeType: "Mime-typ", 
				propImageSize: "Storlek", 
				propImageDownload: "Ladda ner", 
				propImageUpload: "Ladda upp ny", 
				propImageAlternative: "Alternativ text",
				propImageThumb: "Lågupplöst bild", 
				imageDownloadLinkLabel: "Ladda ner bild", 
				
				groupLink: "Länk", 
				propLinkTargetURI: "Target Content", 
				propLinkTargetURITooltip: "Ange ID för det innehåll du vill referera", 
				propLinkTargetURIFind: "Sök innehåll",
				propLinkTargetURL: "Target URL", 
				propLinkTargetURLTooltip: "Ange en url till externt innehåll", 
				
				groupMessage: "Meddelande", 
				propMessageSource: "Källa", 
				propMessageData: "Data",
				
				groupMetaTags: "Metataggar", 
				propContentKeywords: "Nyckelord", 
				propContentDescription: "Beskrivning", 
				propContentRobots: "Robotar", 
				propContentLanguage: "Språk", 
				
				alertErrorLoadingContent: "Kunde inte ladda innehåll", 
				alertErrorSavingFolder: "Kunde inte spara katalog", 
				alertErrorSavingLink: "Kunde inte spara länk", 
				alertErrorSavingDocument: "Kunde inte spara dokument", 
				alertErrorSavingImage: "Kunde inte spara bild", 
				alertErrorSavingArticle: "Kunde inte spara artikel", 
				alertErrorSavingMessage: "Kunde inte spara meddelande", 
				alertContentDataMissing: "Din senaste ändring kunde inte sparas. Innehållet har bytts ut innan ändringen hunnit sparas.", 
				alertContentMustHaveTitle: "Innehåll måste ha en titel", 
				alertUnknownData: "Okännt data, kunde inte spara", 
				alertMissingDependencies: "CMSNodeProperties: missing dependencies"			
			}, 
			search: {
				columnType: "Typ", 
				columnSite: "Sajt", 
				columnTitle: "Titel", 

				byTitleHeader: "Sök innehåll på titel", 
				byTitleFilterLabel: "Titel innehåller:", 
				byTitleButtonText: "Sök", 

				byArticleTextHeader: "Sö innehåll på artikeltext", 
				byArticleTextFilterLabel: "Artikel innehåller:", 
				byArticleTextButtonText: "Sök", 

				byTargetURIHeader: "Sök innehåll på referens", 
				byTargetURIFilterLabel: "Refererat ID:", 
				byTargetURIButtonText: "Sök", 

				typeFolderTooltip: "Katalog", 
				typeLinkTooltip: "Länk", 
				typeDocumentTooltip: "Dokument", 
				typeImageTooltip: "Bild", 
				typeArticleTooltip: "Artikel", 
				typeMessageTooltip: "Meddelande", 
				typeUnknownTooltip: "Okänd typ", 
				
				alertErrorLoading: "CMSSearch: missing dependencies"
			}, 
			toolbar: {
				refreshTooltip: "Uppdatera sajt-träd", 
				searchByTitleTooltip: "Sök innehåll på titel", 
				searchByArticleTextTooltip: "Sök artikel på artikeltext", 
				searchByTargetURITooltip: "Sök innehåll på referens",
				logOut: "Logga ut"
			}			
		}, 
		setUserLanguage: function() {
			try{
				var language = ( navigator.language ? navigator.language : ( navigator.browserLanguage ? navigator.browserLanguage : null));
				if(language){
					if (language.indexOf('en') > -1)
						CMS.editor.language.userLanguage = "en";
					else if (language.indexOf('sv') > -1)
						CMS.editor.language.userLanguage = "sv";
					else if(typeof(CMS.editor.language[language]) !== "undefined")
						CMS.editor.language.userLanguage = language;
				}
			} catch(ex){}
			if(!CMS.editor.language.userLanguage){
			    CMS.editor.language.userLanguage = CMS.editor.language.defaultLanguage;
			}
		}, 
		defaultPhrase: function(panel, item){
			try{
			    if (typeof (CMS.editor.language[CMS.editor.language.defaultLanguage][panel][item]) !== "undefined")
			        return CMS.editor.language[CMS.editor.language.defaultLanguage][panel][item];
			} catch(ex) { }
			return (item || "Undefined phrase");
		}, 
		phrase: function(panel, item){
			var lang = CMS.editor.language;
			if(!lang.userLanguage){
				lang.setUserLanguage();
			}
			try{
				if(typeof(lang[lang.userLanguage]) !== "undefined" && typeof(lang[lang.userLanguage][panel]) !== "undefined" && typeof(lang[lang.userLanguage][panel][item]) !== "undefined")
					return lang[lang.userLanguage][panel][item];
			} catch(ex) { }
			return lang.defaultPhrase(panel, item);
		}
	};
} else {
	alert("CMSLanguage: missing dependencies");
}