﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using cms.DB.IPublished;
using service.Utility;

namespace service
{
    public partial class thumbnail : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            string ticket = FormUtility.Ticket;
            long? contentID = FormUtility.ContentID;

            returnDownloadThumbnail rv = new returnDownloadThumbnail();
            try
            {
                IPublished iPub = new IPublished(FormUtility.Connection);
                rv = iPub.DownloadThumbnail(ticket, contentID);
                if (rv.imageBytes != null && rv.imageBytes.Length == 0)
                {   // available but empty - try to create now
                    rv.imageBytes = new cms.DB.PPlatform.PPlatform(iPub.DbConnection).CreateThumnail(new cms.DB.IFiles.IFiles(iPub.DbConnection).Download(ticket, contentID).bytes, null).thumbnail;
                }
            }
            catch (Exception )
            {
            }

            if (rv.imageBytes != null)
            {
                Response.ContentType = rv.MimeType;
                if (rv.imageBytes.Length > 0) 
                    Response.BinaryWrite(rv.imageBytes);
                Response.End();
            }
        }
    }
}
